var GFM = GFM || {};

GFM.gaEventTracking = (function() {

    var trackDesktopCheckoutEvent = function(eventAction, eventLabel) {
        return trackEvent("desktop-checkout", eventAction, eventLabel);
    };

    var trackMobileCheckoutEvent = function(eventAction, eventLabel) {
        return trackEvent("mobile-checkout", eventAction, eventLabel);
    };

    var trackResponsiveCampaignEvent = function(eventAction, eventLabel) {
        return trackEvent("responsive-campaign", eventAction, eventLabel);
    };

    var trackSearch = function(eventAction, eventLabel) {
        return trackEvent("search", eventAction, eventLabel);
    };

    var trackThankATeacher = function(eventAction, eventLabel) {
        return trackEvent("thankateacher", eventAction, eventLabel);
    };

    var trackLIFG = function(eventAction, eventLabel) {
        return trackEvent("linkedinforgood", eventAction, eventLabel);
    };

    var trackDesktopPostdonate = function(eventAction, eventLabel, eventValue) {
        return trackEvent("desktop-postdonate", eventAction, eventLabel, eventValue);
    };

    var trackMobilePostdonate = function(eventAction, eventLabel, eventValue) {

        if (eventAction === 'comment-fb' && eventValue === GFM.postdonate.actions.accept) {
            if ($('#private-donation-checked-before').val() === '1') {
                GFM.gaEventTracking.trackMobilePostdonate('comment-fb-made-private', gfmPostDonate.currentFlow, GFM.postdonate.actions.accept);
            } else {
                GFM.gaEventTracking.trackMobilePostdonate('comment-fb-made-private', gfmPostDonate.currentFlow, GFM.postdonate.actions.skip);
            }
        }

        if (eventAction === 'more-share' && eventValue === GFM.postdonate.actions.show) {
            if (GFM.utils.userAgentUtils.isIOS()) {
                trackEvent("mobile-postdonate", "more-share-sms", eventLabel, eventValue);
            }
            trackEvent("mobile-postdonate", "more-share-email", eventLabel, eventValue);
            trackEvent("mobile-postdonate", "more-share-tweet", eventLabel, eventValue);
            trackEvent("mobile-postdonate", "more-share-back-to-campaign", eventLabel, eventValue);
            trackEvent("mobile-postdonate", "more-share-another-campaign", eventLabel, eventValue);
        }

        return trackEvent("mobile-postdonate", eventAction, eventLabel, eventValue);
    };

    var trackEvent = function(eventCategory, eventAction, eventLabel, eventValue) {
        if (!window.dataLayer || !(window.dataLayer instanceof Array)) {
            console.log("dataLayer is not initialized");
            console.log("tracking: " + eventCategory + " / " + eventAction + " / " + eventLabel + " / " + eventValue);
        } else {
            // this trigger-ga-event as well as the key names all need to be named exactly so that the configured
            // Google Tag Manager hook fires appropriately.
            // if eventValue is supplied it must be an Int
            window.dataLayer.push({"event" : "trigger-ga-event",
                "eventCategory" : eventCategory,
                "eventAction" : eventAction,
                "eventLabel" : eventLabel,
                "eventValue" : eventValue,
                "nonInteraction" : true
            });
        }
    };

    return {
        trackDesktopCheckoutEvent: trackDesktopCheckoutEvent,
        trackMobileCheckoutEvent: trackMobileCheckoutEvent,
        trackResponsiveCampaignEvent: trackResponsiveCampaignEvent,
        trackEvent: trackEvent,
        trackSearch: trackSearch,
        trackThankATeacher: trackThankATeacher,
        trackLIFG: trackLIFG,
        trackDesktopPostdonate: trackDesktopPostdonate,
        trackMobilePostdonate: trackMobilePostdonate,
    };
})();